IF_NAMEINDEX(3P)

PROLOG
This manual page is part of the POSIX Programmer's Manual. The Linux implementation of this interface may differ (consult the corresponding Linux manual page for details of Linux behavior), or the interface may not be implemented on Linux.

NAME
if_nameindex - return all network interface names and indexes

SYNOPSIS

#include <net/if.h>

struct if_nameindex *if_nameindex(void);

DESCRIPTION

The if_nameindex() function shall return an array of if_nameindex structures, one structure per interface. The end of the array is indicated by a structure with an if_index field of zero and an if_name field of NULL.

Applications should call if_freenameindex() to release the memory that may be dynamically allocated by this function, after they have finished using it.

RETURN VALUE

An array of structures identifying local interfaces. A NULL pointer is returned upon an error, with errno set to indicate the error.

ERRORS

The if_nameindex() function may fail if:

ENOBUFS
    Insufficient resources are available to complete the function.

The following sections are informative.

EXAMPLES

None.

APPLICATION USAGE

None.

RATIONALE

None.

FUTURE DIRECTIONS

None.

SEE ALSO

getsockopt(), if_freenameindex(), if_indextoname(), if_nametoindex(), setsockopt(), the Base Definitions volume of IEEE Std 1003.1-2001, <net/if.h>

COPYRIGHT
Portions of this text are reprinted and reproduced in electronic form from IEEE Std 1003.1, 2003 Edition, Standard for Information Technology -- Portable Operating System Interface (POSIX), The Open Group Base Specifications Issue 6, Copyright (C) 2001-2003 by the Institute of Electrical and Electronics Engineers, Inc and The Open Group. In the event of any discrepancy between this version and the original IEEE and The Open Group Standard, the original IEEE and The Open Group Standard is the referee document. The original Standard can be obtained online at http://www.opengroup.org/unix/online.html .